function element = GenerateWorldElement(params, type)

% type =
%        'LineSegment' --> params - a 2x2 matrix defining coordinates of the end points

switch type

    case 'LineSegment'

        element.type = 'LineSegment';
        element.ends = params;
        element.Center = mean(element.ends')';
        element.RMax = norm(element.ends(:,2)-element.ends(:,1))/2;
        element.etc.SegmentVector = element.ends(:,2)-element.ends(:,1);
        element.etc.SegmentLength = sqrt(sum(element.etc.SegmentVector.^2));
        element.etc.SegmentUnitVector = element.etc.SegmentVector / element.etc.SegmentLength;
        al = element.ends(2,2) - element.ends(2,1);
        bl = element.ends(1,1) - element.ends(1,2);
        cl = element.ends(2,1)*element.ends(1,2) - element.ends(1,1)*element.ends(2,2);
        mag = sqrt(al*al + bl*bl);
        element.etc.an = al / mag;
        element.etc.bn = bl / mag;
        element.etc.cn = cl / mag;

end
