function SLAM_example(spec_filename)

global Control
global VGraph Obstacles
global NowCoord GoalCoord

% Structure Control
%                  .params
%                         .RobotRadius
%                         .FeedbackLinearizationDistance
%                         .Clearance_KnownObstacles
%                         .Clearance_GeneratedObstacles
%                         .PathDiscretizationResolution
%                  .PathPoints
%                             .NowIndex
%                             .points
Control.params.RobotRadius = 0.1;
Control.params.FeedbackLinearizationDistance = 0.05;
Control.params.Clearance_KnownObstacles = 0.05; % 0.2;
Control.params.Clearance_GeneratedObstacles = 0.15;

Control.params.PathDiscretizationResolution = 0.01;

Control.params.SearchAheadDistForClosestPoint = 1.0;
Control.params.TargetPointDistanceAhead = 0.03; %0.2;

Control.params.RobotSpeed = 0.2;


Robot_Communicate('initiate', {'laser'});

InitiateUObstacle(spec_filename);
DrawScene('initiate');
DrawScene('GoalPoint');
DrawScene('UObstacles_Geometry');

GenerateObstacles;

DrawScene('Obstacles');
DrawScene('NowPoint');