function DiscretizeLeastCostPath
%{
******************************************************************************************
*                                                                                        *
*    A* search with homotopy class constraints                                           *
*    Copyright (C) 2010  Subhrajit Bhattacharya                                          *
*                                                                                        *
*    This program is free software: you can redistribute it and/or modify                *
*    it under the terms of the GNU General Public License as published by                *
*    the Free Software Foundation, either version 3 of the License, or                   *
*    (at your option) any later version.                                                 *
*                                                                                        *
*    This program is distributed in the hope that it will be useful,                     *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of                      *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                       *
*    GNU General Public License for more details <http://www.gnu.org/licenses/>.         *
*                                                                                        *
*                                                                                        *
*    Contact: subhrajit@gmail.com, http://fling.seas.upenn.edu/~subhrabh/                *
*                                                                                        *
*                                                                                        *
******************************************************************************************
%}


global VGraph Control

% Structure Control
%                  .PathPoints
%                             .NowIndex
%                             .points

Control.PathPoints.points = [];
for a = 1:length(VGraph.LeastCostPath)
    
    p1 = [ VGraph.VertexCluster{VGraph.LeastCostPath(a).i}.Vertices(1,VGraph.LeastCostPath(a).v_i); ...
           VGraph.VertexCluster{VGraph.LeastCostPath(a).i}.Vertices(2,VGraph.LeastCostPath(a).v_i) ];
    p2 = [ VGraph.VertexCluster{VGraph.LeastCostPath(a).j}.Vertices(1,VGraph.LeastCostPath(a).v_j); ...
        VGraph.VertexCluster{VGraph.LeastCostPath(a).j}.Vertices(2,VGraph.LeastCostPath(a).v_j) ];
    if VGraph.LeastCostPath(a).direction == -1
        p = p1;
        p1 = p2;
        p2 = p;
    end

    interNo = round(norm(p1-p2)/Control.params.PathDiscretizationResolution);
    Control.PathPoints.points = [ Control.PathPoints.points , repmat(p1,[1 interNo+1])+repmat(p2-p1,[1 interNo+1]).*repmat((0:interNo)/interNo,[2 1]) ];
    
end

Control.PathPoints.NowIndex = 1;
