function NowCoordReturn = GetNowCoord(pt, dirn)
global Obstacles
% If the point pt is inside an obstacle, this returns a point which is
% outside the obstacle

for a = 1:Obstacles.N
    
    vNo = size(Obstacles.obs{a}.Vertices, 2);
    vertexPos = Obstacles.obs{a}.Vertices(1:2,:) - repmat(pt,[1 vNo]);
    vertexDirn = atan2(vertexPos(2,:), vertexPos(1,:));
    
    aheadIndex = (-pi/2 < vertexDirn) & (vertexDirn < pi/2);
    [nearestDistSq, nearestIndex] = min(sum(vertexPos.^2));
    
    NearIndex(a) = aheadIndex(nearestIndex);
    NearDistSq(a) = nearestDistSq;
    
end

[BestDist, BestObs] = min(NearDistSq);
NowCoordReturn = Obstacles.obs{BestObs}.Vertices(1:2,NearIndex(BestObs));
