function AuxiliaryEdgeColumn = ComputeAuxiliaryEdgeColumn(v1, v2)
% v1 and v2 are the actual coordinates of points (2xN matrices)
% AuxiliaryEdgeColumn is a 4xN matrices consisting the following:
%           AuxiliaryEdgeColumn(1,:) -- length of the line segments
%           AuxiliaryEdgeColumn(2:4,:) -- coeficients a,b and c that define the line of the edges: ax+by+c=0
%

v12 = v1 - v2;
AuxiliaryEdgeColumn(1,:) = sqrt(sum(v12.^2));

AuxiliaryEdgeColumn(2,:) = v2(2,:) - v1(2,:);
AuxiliaryEdgeColumn(3,:) = v1(1,:) - v2(1,:);
AuxiliaryEdgeColumn(4,:) = v1(2,:).*v2(1,:) - v1(1,:).*v2(2,:);
