#ifndef TRACKING_NOISY_HH
#define TRACKING_NOISY_HH

#include <gazebo/Model.hh>

typedef struct gz_truth gz_truth_t;


class Tracking_Noisy : public Model
{
  // Constructor, destructor
  public: Tracking_Noisy( World *world );
  public: virtual ~Tracking_Noisy();
  
  // Load the model
  public: virtual int Load( WorldFile *file, WorldFileNode *node );

  // Initialize the model
  public: virtual int Init( WorldFile *file, WorldFileNode *node );

  // Finalize the model
  public: virtual int Fini();

  // Update the model state
  public: virtual void Update( double step );

  // Initialize the external interface
  private: int IfaceInit();

  // Finalize the external interface
  private: int IfaceFini();

  // Get commands from the interface
  private: bool IfaceGetCmd(GzVector *pos, GzQuatern *rot);

  // Update the data in the external interface
  private: void IfacePutData();

  // External interfaces
  private: gz_truth_t *truth_iface;

  // Body that we must have
  private: Body *body;

private: double cov_x, cov_y, cov_theta;
private: gsl_rng *rng;  // gsl random number generator
};


#endif
